---
title: Introduction
metaTitle: API Reference - Handsontable Documentation
permalink: /11.0/api/
canonicalUrl: /api/
---

# Handsontable API Reference

[[toc]]

Welcome to Handsontable API reference. Our goal is make it easy to dive in and start coding from day one.

The API enables you to control the data grid programmatically. With this API, you can:

-   Configure options
-   Use methods to integrate it with your app
-   Use hooks to interact with what's happening in the grid
-   Introduce new integrations
-   and more

**This reference comprises four sections:**

### [Core](@/api/core.md)

The `Handsontable` class controls the essential aspects of the data grid.

### [Hooks](@/api/hooks.md)

Hooks are two-directional events that fire whenever a specific action occurs within the instance of Handsontable.

### [Options](@/api/options.md)

These are the settings available to be registered for the `Core` features, in addition to those provided by plugins.

### [Plugins](@/api/plugins.md)

The plugins extend the capabilities of Handsontable.

## Getting help

If you need help using the API reference, please [contact our Support](https://handsontable.com/contact?category=technical_support).
