---
title: Software license
metaTitle: Software license - Guide - Handsontable Documentation
permalink: /12.1/software-license
canonicalUrl: /software-license
---

# Software license

[[toc]]

The source code is available under two types of license in order to make it a better fit for different types of projects.

You are required to specify the license under which you use the software. This can be done by entering the corresponding keyword or a generated commercial [license key](@/guides/getting-started/license-key.md) in the `Settings` object.

## Available licenses

| Name | Type |
| :--- | :--- |
| [Non-Commercial License](https://handsontable.com/static/licenses/non-commercial/v2/handsontable-non-commercial-license.pdf) | Proprietary |
| Commercial License Agreement | Proprietary |

## Non-commercial use

We allow you to use this software for such non-commercial purposes as, but not limited to, research, private study, and evaluation. Your use in commercial settings is strictly limited to evaluation, development and testing tier of a software deployment architecture.

**In other words, you can’t enter the production stage if your project is anyhow connected with your commercial activity.**

If you want to use Handsontable in a non-commercial or an open-source project, then head to the [License Key](@/guides/getting-started/license-key.md) page to learn about the corresponding license key.

## Commercial use

If you are interested in obtaining a commercial license key, you should contact our sales team directly through the [contact form](https://handsontable.com/contact?category=request_for_quotation) or by email at [sales@handsontable.com](mailto:sales@handsontable.com).

The enterprise license is available on demand.

## How to use the license key

You can find the details about adding the license key on [this page](@/guides/getting-started/license-key.md).

## Open-source license

For many years Handsontable was available as an open-source software, and released under the MIT license. The last version available under permissive terms was [6.2.2](https://github.com/handsontable/handsontable/tree/6.2.2) released on December 19, 2018.

## Related articles

### Related guides

- [License key](@/guides/getting-started/license-key.md)

### Related API reference

- Options: 
  - [`licenseKey`](@/api/options.md#licensekey)